datablock projectileData(exponentialRocket : rocketLauncherProjectile)
{
	uiName = "";
	maxIterations = 3; // The total number of splits to do
	splitTime = 700; // The time in milliseconds to wait before splitting again
	numSplits = 2; // Number of new projectiles to split into
	
	muzzleVelocity = 50; // How fast it travels (Default rocket launcher is 65)
	directDamage = 100; // How much damage the weapon does. Note: As the rockets split, the damage is split evenly between them.
};

datablock itemData(exponentialRocketLauncherItem : rocketLauncherItem)
{
	uiName = "Exponential Rocket Launcher";
	image = exponentialRocketLauncherImage;
};

datablock shapeBaseImageData(exponentialRocketLauncherImage : rocketLauncherImage)
{
	item = exponentialRocketLauncherItem;
	projectile = exponentialRocket;
	stateFire[2] = false;
};

function exponentialRocketLauncherImage::onFire(%this, %obj, %slot)
{
	%proj = new Projectile()
	{
		datablock = %this.projectile;
		initialPosition = %obj.getMuzzlePoint(%slot);
		initialVelocity = vectorScale(%obj.getMuzzleVector(%slot), %this.projectile.muzzleVelocity);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
		exponentialIterations = 0;
	};
	
	%proj.schedule(%this.projectile.splitTime, exponentialSplit);
}

function projectile::exponentialSplit(%this)
{
	%datablock = %this.getDatablock();
	
	if(%this.iterations > %datablock.maxIterations)
		return;
	
	%iterations = %this.iterations;
	%iterations++;
	//echo(%iterations SPC %this.iterations SPC %datablock.maxIterations);
	
	%vel = %this.getVelocity();
	
	if(%vel $= "0 0 0")
		return;
	
	%scale = vectorScale(%this.getScale(), 1 / %datablock.numSplits);
	%pos = %this.getPosition();
	
	for(%i = 0; %i < %datablock.numSplits; %i++)
	{
		%random = vectorAdd(getRandom() * (getRandom(0, 1) == 1 ? -1 : 1) SPC getRandom() * (getRandom(0, 1) == 1 ? -1 : 1) SPC getRandom() * (getRandom(0, 1) == 1 ? -1 : 1), %vel);
		%proj = new Projectile()
		{
			datablock = %datablock;
			initialPosition = %pos;
			initialVelocity = %random;
			sourceObject = %this.sourceObject;
			sourceSlot = %this.sourceSlot;
			client = %this.client;
		};
		
		%proj.iterations = %iterations;
		%proj.setScale(%scale);
		%proj.schedule(%datablock.splitTime, exponentialSplit);
	}
	
	%this.delete();
}